datacovid/urls.py
from django.urls import path
from . import views

app_name = 'datacovid'

urlpatterns = [
    path('', views.datacovid, name='datacovid'),
    path('formdata', views.formdata, name='formdata'),
    path('load-more', views.load_more, name='load-more'),
    path('get_content', views.get_content, name='get_content'),
    path('post_content', views.post_content, name='post_content')
]

home/urls.py
from django.urls import path
from .views import index

app_name='home'

urlpatterns= [
    path('', index, name='home')
]

project_name/urls.py
from django.contrib import admin
import diskusi.urls as diskusi_urls
from django.urls import include, path, re_path
from home.views import index as home

urlpatterns = [
    path('admin/', admin.site.urls),
    path('rumah-sakit-rujukan/', include('rujukan.urls')),
    path('kewaspadaan/', include('kewaspadaan.urls')),
    path('home', include('home.urls')),
    path('diskusi/', include(diskusi_urls)),
    path('data-covid/', include('datacovid.urls')),
    path('vaksinasi/', include('vaksinasi.urls')),
    path('', include('login.urls', 'login')),
    re_path(r'^$', home, name='home'),
]

datacovid/models.py
from django.db import models

# Create your models here.
class DataCovid(models.Model):
    daerah = models.CharField('daerah', max_length=200)
    positif = models.CharField('positif', max_length=200)

    

datacovid/forms.py
from django import forms
from .models import DataCovid

class dataform(forms.ModelForm):
    class Meta:
        model = DataCovid
        fields = ['daerah', 'positif']

datacovid/views.py
from django.http.response import HttpResponse
from django.shortcuts import render, redirect
from .models import DataCovid
from .forms import dataform
from django.core import serializers
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required
from django.views.decorators.csrf import csrf_exempt
import json

# Create your views here.
def datacovid(request):
    data = DataCovid.objects.all()
    three_data = data[:3]
    response = {'data': data,
    'three_data' : three_data
    }
    return render(request, 'datacovid.html', response)

@login_required(login_url='/admin/login/')
def formdata(request):
    add_data = dataform(request.POST or None)
    if (add_data.is_valid() and request.method == 'POST'):
        add_data.save()
        return redirect('/data-covid')
    response = {'formdata': add_data}
    return render(request, 'datacovid_form.html', response)

def load_more(request):
    offset = int(request.POST.get('offset', 0))
    limit = 3
    posts = DataCovid.objects.all()[offset:limit+offset]
    totalData = DataCovid.objects.count()
    data = {}
    posts_json = serializers.serialize('json', posts)
    return JsonResponse(data={
        'posts': posts_json,
        'totalResult': totalData
    })

@csrf_exempt
def get_content(request):
    res = []
    content = DataCovid.objects.all()
    for i in content:
        dict = {
            "daerah" : i.daerah,
            "positif" : i.positif
        }
        res.append(dict)
    data = json.dumps(res)
    print(data) 
    return HttpResponse(data, content_type='application/json')

@csrf_exempt
def post_content(request):
    data = json.loads(request.body)
    form = dataform(data)
    form.save()

    response = HttpResponse('success')
    response.status_code = 200
    return response

datacovid/templates/datacovid.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<meta charset="UTF-8" />
{% endblock meta %}

{% block css %}
<!-- bootstraps css -->
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
<!-- bootstrap js -->
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
{% endblock css %}

{% block title %}
Data Covid-19
{% endblock title %}

{% block content %}
<body>
  <br><br><br><br>
  <div>
    <h1 class="text-lg-center" style="color: #252B42;"><strong>Data Covid-19 Nasional</strong></h1> 
    <h5 class="text-center" style="color: #827E7E;">Data berikut merupakan akumulasi data pasien Covid-19 yang dirawat di Indonesia</h5>
  </div>
  <br><br>
  <div>
    <div class="container-fluid">
    <div class="row">
      <div class="col-sm-4">
        <div class="card">
          <div class="card-header">
            <h5 class="card-title">Kasus Positif Covid-19 Nasional</h5>
          </div>
          <div class="card-body">
            <h4 class="card-text" style="color: rgb(143, 45, 45);">4.247.320</h4>
          </div>
        </div>
      </div>
      <div class="col-sm-4">
        <div class="card">
          <div class="card-header">
            <h5 class="card-title">Kasus Sembuh Covid-19 Nasional</h5>
          </div>
          <div class="card-body">
            <h4 class="card-text" style="color: rgb(143, 45, 45);">4.092.586</h4>
          </div>
        </div>
      </div>
      <div class="col-sm-4">
        <div class="card">
          <div class="card-header">
            <h5 class="card-title">Kasus Meninggal Covid-19 Nasional</h5>
          </div>
          <div class="card-body">
            <h4 class="card-text" style="color: rgb(143, 45, 45);">143.519</h4>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<br>
<div>
  <p style="color: #827E7E;">*Data kasus Covid-19 adalah data dummy dan dapat berubah sewaktu-waktu</p>
</div>
  <br><br>
  <div>
    <div class="container-xl">
    <div class="table-responsive-md">
      <table class="table table-hover table-bordered">
        <thead>
          <tr>
            <td colspan=4 class="text-center"><strong>SUSPEK</strong></td>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>3.927.113 (95,2%) ISOLASI</td>
            <td>197.517 (4,8%) SEMBUH</td>
            <td>40 (0,0%) MENINGGAL</td>
            <td>4.166.092 TOTAL</td>
          </tr>
        </tbody>
        <tbody>
          <tr>
            <td colspan=4 class="text-center"><strong>KONTAK ERAT</strong></td>
          </tr>
        </tbody>
        <tbody>
          <tr>
            <td>1.822.917 (99,7%) ISOLASI</td>
            <td>6.452 (0,4%) SEMBUH</td>
            <td>0 (0,0%) MENINGGAL</td>
            <td>1.829.398 TOTAL</td>
          </tr>
        </tbody>
        <tbody>
          <tr>
            <td colspan=4 class="text-center"><strong>PELAKU PERJALANAN</strong></td>
          </tr>
        </tbody>
        <tbody>
        <tr>
          <td>520.736 (88,2%) ISOLASI</td>
          <td>69.481 (11,8%) SEMBUH</td>
          <td>40 (0,0%) MENINGGAL</td>
          <td>590.217 TOTAL</td>
        </tr>
      </tbody>
      </table>
    </div> 
  </div>
</div>
  <div>
    <p class="tex-sm" style="color: #827E7E;">*Data suspek, kontak erat, dan pelaku perjalanan merupakan data dummy</p>
  </div>
  <br><br><br><br>
  <div>
    <h3 class="text-lg-center" style="color: #252B42;"><strong>Grafik Covid-19 Nasional</strong></h3>
  </div>
  <br>
  <div>
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <script type="text/javascript">
      google.charts.load('current', {'packages':['corechart']});
      google.charts.setOnLoadCallback(drawChart);

      function drawChart() {
        var data = google.visualization.arrayToDataTable([
          ['Month', 'Kasus positif Covid-19'],
          ['Januari',  1000],
          ['Februari',  1170],
          ['Maret',  660],
          ['April',  1030]
        ]);

        var options = {
          title: 'Kasus positif Covid-19 di Indonesia Kuarter I 2021',
          curveType: 'function',
          legend: { position: 'bottom' }
        };

        var chart = new google.visualization.LineChart(document.getElementById('curve_chart'));

        chart.draw(data, options);
      }
    </script>
    <body>
      <div class="container">
      <div id="curve_chart"></div>
    </body>
  </div>
</div>
  <br><br><br><br><br>
  <div>
    <h3 class="text-lg-center" style="color: #252B42;"><strong>Data Covid-19 Per Daerah</strong></h3>
    <p class="text-lg-center" style="color: #827E7E;">Data Covid-19 bersifat dummy dan dapat berubah sewaktu-waktu</p>
  </div>
  <br>
  <div class="container-sm">
  <div class="row gx-5 kasus-wrapper">
      {% for element in three_data %}
      <div class="col-lg-4 mb-5">
        <div class="card">
          <div class="card-body">
            <div class="h5 card-title">Daerah: {{ element.daerah }}</div>
            <p class="card-text">Kasus: {{ element.positif }}</p>
        </div>
      </div>
    </div>
    {% endfor %}
  </div>
</div>
  <p class="text-center">
    <button class="btn btn-outline-dark" id="loadmoreBtn">Load More</button>
  </p>
  <div>
    <p class="text-center">
      <a class="btn btn-dark" href="/data-covid/formdata" role="button" id="tambahBtn">Tambah</a>
    </p>
  </div>
<br><br><br><br>
<script src="https://code.jquery.com/jquery-3.5.1.min.js"></script> 
  <script>
      $(document).ready(function(){
          $("#loadmoreBtn").on('click',function(){
              var _currentResult=$(".mb-5").length;
              // Run Ajax
              $.ajax({
                  url:"{% url 'datacovid:load-more' %}",
                  type:'post',
                  data:{
                      'offset': _currentResult,
                      'csrfmiddlewaretoken':"{{csrf_token}}"
                  },
                  dataType:'json',
                  beforeSend:function(){
                      $("#loadmoreBtn").addClass('disabled').text('Loading..');
                  },
                  success:function(res){
                      var _html='';
                      var json_data=$.parseJSON(res.posts);
                      $.each(json_data,function(index,data){
                          _html+= '<div class="col-lg-4 mb-5">\
                          <div class="card">\
                            <div class="card-body">\
                              <div class="h5 card-title">Daerah: '+data.fields.daerah+'</div>\
                              <p class="card-text">Kasus: '+data.fields.positif+'</p>\
                              </div>\
                              </div>\
                            </div>';
                      });
                      $(".kasus-wrapper").append(_html);
                      var _countTotal=$(".mb-5").length;
                      if(_countTotal==res.totalResult){
                          $("#loadmoreBtn").remove();
                      }else{
                          $("#loadmoreBtn").removeClass('disabled').text('Load More');
                      }
                  }
              });
          });
      });
  </script> 
  </body> 
    {% endblock %}

datacovid/templates/datacovid_form.html
{% extends 'base.html' %}
{%load static%}
{%block content%}
<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8" />
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
    </head>
    <body>
      <br><br><br><br>
      <div> 
        <h2 class="text-center" style="color: #000000;"><strong>Form Data Covid</strong></h2>
        <p class="text-center" style="color: #000000;">Silakan isi form di bawah ini untuk menambahkan data daerah kasus Covid-19😊</p>
      </div>
      <div>
        <div class="container">
        <form method="POST" action="" class="addForm"> {% csrf_token %}
            <div class="col">
              <label for="toField" style="color: rgb(0, 0, 0)">Daerah:</label>
            <input type="text" id="toField" class="form-control" placeholder="Tulis nama daerah" name="daerah" >
          </div>
        <br>
        <div class="col">
          <label for="fromField" style="color: rgb(0, 0, 0)">Kasus positif:</label>
            <input type="text" id="fromField" class="form-control" placeholder="Tulis jumlah kasus positif" name="positif">
        </div>
        <br>
          <input type ="submit" value="Submit" class="submitButton">
        </form>
      </div>
    </div>
        </body>
        </html>
        {%endblock content%}